#!/usr/bin/perl
use Socket;

$prog=$0;
$prog =~ s,.*/,,;

$sflg=0;
$vflg=0;
while ($ARGV[0] =~ /^-/) {
	if ($ARGV[0] eq "-s") {
		$sflg=1;
	} elsif ($ARGV[0] eq "-v") {
		$vflg=1;
	} else {
		print STDERR "Usage: $prog [-s] [-v] hostname...\n";
		print STDERR "\t-s silent on DNS lookup failures\n";
		print STDERR "\t-v verbose on DNS lookup\n";
	}
	shift @ARGV;
}

foreach $arg (@ARGV) {
	if ($arg =~ /^[0-9.]+$/) {
		($ipa, $ipb, $ipc, $ipd)=split("\\.", $arg);
		($name, $aliases, $addrtype, $length, @addrs)=gethostbyaddr(pack("C4", $ipa, $ipb, $ipc, $ipd), 2);
	} else {
		($name, $aliases, $addrtype, $length, @addrs)=gethostbyname($arg);
	}
	if ($name) {
		if ($vflg) {
			print "$arg:\n";
			print "\tname=$name\n";
			print "\taliases=$aliases\n";
			print "\taddrtype=$addrtype\n";
			print "\tlength=$length\n";
			print "\taddrs:";
			foreach $a (@addrs) {
				($ipa, $ipb, $ipc, $ipd)=unpack("C4", $a);
				print " $ipa.$ipb.$ipc.$ipd";
			}
			print "\n";
		} else {
			foreach $a (@addrs) {
				($ipa, $ipb, $ipc, $ipd)=unpack("C4", $a);
				print "$ipa.$ipb.$ipc.$ipd";
				print "\t$name";
				if ($aliases) {
					print " $aliases";
				}
				print "\n";
			}
		}
	} else {
		if (!$sflg) {
			print STDERR "$arg: Not found\n";
		}
	}
}
